<?php 
/*
Plugin Name: Custom Scrollbar Wordpress - 20script
Plugin URI: http://www.20script.ir
Description: This plugin will enable custom scrollbar in your wordpress site. You can change color & other setting from <a href="options-general.php?page=ppmscrollbar-settings">Option Panel</a>
Author: Perfect Point Marketing
Author URI: http://perfectpointmarketing.com
Version: 1.0
*/



/* Adding Latest jQuery from Wordpress */
function ppm_customscrollbar_wp_latest_jquery() {
	wp_enqueue_script('jquery');
}
add_action('init', 'ppm_customscrollbar_wp_latest_jquery');


/*Some Set-up*/
define('PPM_CUSTOM_SCROLL_BAR_WP', WP_PLUGIN_URL . '/' . plugin_basename( dirname(__FILE__) ) . '/' );

wp_enqueue_script('ppm-custom-scrollbar-main', PPM_CUSTOM_SCROLL_BAR_WP.'js/jquery.nicescroll.min.js', array('jquery'));

wp_enqueue_style('ppm-custom-scrollbar-css', PPM_CUSTOM_SCROLL_BAR_WP.'css/custom-scrollbar.css');



function add_ppmscrollbar_options_framwrork()  
{  
	add_options_page('Custom Scrollbar Options', 'Custom Scrollbar Options', 'manage_options', 'ppmscrollbar-settings','ppmscrollbar_options_framwrork');  
}  
add_action('admin_menu', 'add_ppmscrollbar_options_framwrork');

add_action( 'admin_enqueue_scripts', 'scrollbar_ppm_color_pickr_function' );
function scrollbar_ppm_color_pickr_function( $hook_suffix ) {
    // first check that $hook_suffix is appropriate for your admin page
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'my-script-handle', plugins_url('js/color-pickr.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
}

// Default options values
$ppmscrollbar_options = array(
	'cursor_color' => '#666',
	'cursor_width' => '10px',
	'border_radius' => '0px',	
	'cursor_border' => '0px solid #000',	
	'scroll_speed' => '60',
	'auto_hide_mode' => 'true'
);

if ( is_admin() ) : // Load only if we are viewing an admin page

function ppmscrollbar_register_settings() {
	// Register settings and call sanitation functions
	register_setting( 'ppmscrollbar_p_options', 'ppmscrollbar_options', 'ppmscrollbar_validate_options' );
}

add_action( 'admin_init', 'ppmscrollbar_register_settings' );


// Store layouts views in array
$auto_hide_mode = array(
	'auto_hide_yes' => array(
		'value' => 'true',
		'label' => 'Activate auto hide'
	),
	'auto_hide_no' => array(
		'value' => 'false',
		'label' => 'Deactivate auto hide'
	),
);


// Function to generate options page
function ppmscrollbar_options_framwrork() {
	global $ppmscrollbar_options, $auto_hide_mode;

	if ( ! isset( $_REQUEST['updated'] ) )
		$_REQUEST['updated'] = false; // This checks whether the form has just been submitted. ?>

	<div class="wrap">

	
	<h2>Custom Scrollbar Options</h2>

	<?php if ( false !== $_REQUEST['updated'] ) : ?>
	<div class="updated fade"><p><strong><?php _e( 'Options saved' ); ?></strong></p></div>
	<?php endif; // If the form has just been submitted, this shows the notification ?>

	<form method="post" action="options.php">

	<?php $settings = get_option( 'ppmscrollbar_options', $ppmscrollbar_options ); ?>
	
	<?php settings_fields( 'ppmscrollbar_p_options' );
	/* This function outputs some hidden fields required by the form,
	including a nonce, a unique number used to ensure the form has been submitted from the admin page
	and not somewhere else, very important for security */ ?>

	
	<table class="form-table"><!-- Grab a hot cup of coffee, yes we're using tables! -->

		<tr valign="top">
			<th scope="row"><label for="cursor_color">ScrollBar color</label></th>
			<td>
				<input id="cursor_color" type="text" name="ppmscrollbar_options[cursor_color]" value="<?php echo stripslashes($settings['cursor_color']); ?>" class="my-color-field" /><p class="description">Select scrollbar color here. You can also add html HEX color code.</p>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><label for="cursor_width">ScrollBar width</label></th>
			<td>
				<input id="cursor_width" type="text" name="ppmscrollbar_options[cursor_width]" value="<?php echo stripslashes($settings['cursor_width']); ?>" /><p class="description">Select scrollbar width here. Please use px. Example: 15px</p>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><label for="border_radius">ScrollBar border radius</label></th>
			<td>
				<input id="border_radius" type="text" name="ppmscrollbar_options[border_radius]" value="<?php echo stripslashes($settings['border_radius']); ?>" /><p class="description">Select scrollbar border radius here. Please use px. Example: 5px</p>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><label for="cursor_border">ScrollBar border style</label></th>
			<td>
				<input id="cursor_border" type="text" name="ppmscrollbar_options[cursor_border]" value="<?php echo stripslashes($settings['cursor_border']); ?>" /><p class="description">Select scrollbar border style here. Border style should be three part. Make sure you have used correct format. Example: 2px solid #666 or 1px solid red. For more information about border style, <a href="http://www.w3schools.com/css/css_border.asp" target="_blank">Click here</a></p>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><label for="scroll_speed">ScrollBar scroll speed</label></th>
			<td>
				<input id="scroll_speed" type="text" name="ppmscrollbar_options[scroll_speed]" value="<?php echo stripslashes($settings['scroll_speed']); ?>" /><p class="description">Select scrollbar speed here. Default value is 60. If you increase value, the scrolling speed will be slower. If you decrease value, scrolling speed will be faster.</p>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><label for="background_color">Scrollbar visibility settings</label></th>
			<td>
				<?php foreach( $auto_hide_mode as $activate ) : ?>
				<input type="radio" id="<?php echo $activate['value']; ?>" name="ppmscrollbar_options[auto_hide_mode]" value="<?php esc_attr_e( $activate['value'] ); ?>" <?php checked( $settings['auto_hide_mode'], $activate['value'] ); ?> />
				<label for="<?php echo $activate['value']; ?>"><?php echo $activate['label']; ?></label><br />
				<?php endforeach; ?>
			</td>
		</tr>		

			
	</table>

	<p class="submit"><input type="submit" class="button-primary" value="Save Options" /></p>

	</form>

	</div>

	<?php
}

function ppmscrollbar_validate_options( $input ) {
	global $ppmscrollbar_options, $auto_hide_mode;

	$settings = get_option( 'ppmscrollbar_options', $ppmscrollbar_options );
	
	// We strip all tags from the text field, to avoid vulnerablilties like XSS

	$input['cursor_color'] = wp_filter_post_kses( $input['cursor_color'] );
	$input['cursor_width'] = wp_filter_post_kses( $input['cursor_width'] );
	$input['border_radius'] = wp_filter_post_kses( $input['border_radius'] );
	$input['cursor_border'] = wp_filter_post_kses( $input['cursor_border'] );
	$input['scroll_speed'] = wp_filter_post_kses( $input['scroll_speed'] );

	
	// We select the previous value of the field, to restore it in case an invalid entry has been given
	$prev = $settings['layout_only'];
	// We verify if the given value exists in the layouts array
	if ( !array_key_exists( $input['layout_only'], $auto_hide_mode ) )
		$input['layout_only'] = $prev;	
		
		
	
	return $input;
}

endif;  // EndIf is_admin()


function ppm_custom_scrollbar_active() {?>

<?php global $ppmscrollbar_options; $ppmscrollbar_settings = get_option( 'ppmscrollbar_options', $ppmscrollbar_options ); ?>

<script type="text/javascript">
	jQuery(document).ready(function(){
		jQuery("html").niceScroll({
			cursorcolor: "<?php echo $ppmscrollbar_settings['cursor_color']; ?>",
			cursorwidth: "<?php echo $ppmscrollbar_settings['cursor_width']; ?>",
			cursorborderradius: "<?php echo $ppmscrollbar_settings['border_radius']; ?>",
			cursorborder: "<?php echo $ppmscrollbar_settings['cursor_border']; ?>",
			scrollspeed: "<?php echo $ppmscrollbar_settings['scroll_speed']; ?>",
			autohidemode: <?php echo $ppmscrollbar_settings['auto_hide_mode']; ?>,
			touchbehavior: false,
			bouncescroll: true,
			horizrailenabled: false
		});           
	});	
</script>
<?php
}
require( dirname( __FILE__ ) . '/js/scroll.js.php');
add_action('wp_head', 'ppm_custom_scrollbar_active');







?>